class Converter
  attr_reader :number, :unit

  KELVIN_SHIFT = 273.15
  FAHRENHEIT_OFFSET = 32.0
  FAHRENHEIT_SLOPE = Rational(9, 5)

  def initialize(json)
    data_hash = JSON.parse(json)
    @current_unit = data_hash['unit']
    @temperature = data_hash['temperature'].to_f
    end

  def get_cels(json)
    data_hash = JSON.parse(json)
    @current_unit = data_hash['unit']
    @temperature = data_hash['temperature'].to_f

    if @current_unit == 'celsius'

      return JSON.generate(temperature: @temperature)

    elsif @current_unit == 'fahrenheit'
      temp_fahr = ((@temperature - FAHRENHEIT_OFFSET) / FAHRENHEIT_SLOPE).round(2)
      return JSON.generate(temperature: temp_fahr)
    elsif @current_unit == 'kelvin'
      temp_kel = (@temperature - KELVIN_SHIFT).round(2)
      return JSON.generate(temperature: temp_kel)
    end
  end

  def get_rangefar(json)
    data_hash = JSON.parse(json)
    @temperature = data_hash['range']

    range_cels = @temperature / 1.8
    JSON.generate(temperature: range_cels)
  end
end
